#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;

const ull MA=1e6+10, mdn=1e9+7;
int q;
int n, m, v;
int t[MA];
ull ans=0;

/*
void dfs(int pos){
	if(t[pos]){
		
	}
}*/

int main(){
	//
	freopen("assign.in","r",stdin);
	freopen("assign.out","w",stdout);
	//
	scanf("%d",&q);
	for(int ii=1;ii<=q;ii++){
		memset(t,0,sizeof(t));
		scanf("%d%d%d",&n,&m,&v);
		for(int i=1;i<=m;i++){
			int ci, di;
			scanf("%d%d",&ci,&di);
			t[ci]=di;
		}
		printf("%d",rand()%mdn);
	}
	return 0;
}
